#ifndef _HALFEDGE_H_
#define _HALFEDGE_H_

#include "Edge.h"

class Vertex;
class Face;

class HalfEdge
{
public:
	HalfEdge(){ m_edge = NULL; m_vertex = NULL; m_prev = NULL; m_next = NULL; m_face = NULL;}
	~HalfEdge()	{;}
	Edge     * & edge()    { return m_edge;   }
	Vertex   * & vertex()  { return m_vertex; }
	Vertex   * & target()  { return m_vertex; }
	Vertex   * & source()  { return m_prev->vertex();}
	HalfEdge * & he_prev() { return m_prev;}
	HalfEdge * & he_next() { return m_next;}
	HalfEdge * & he_twin()  { return m_edge->twin(this); }
	Face     * & face()    { return m_face;}

	HalfEdge * ccw_rotate_about_target();
	HalfEdge * clw_rotate_about_target();
	HalfEdge * ccw_rotate_about_source();
	HalfEdge * clw_rotate_about_source();

protected:
	Edge     *     m_edge;
	Face     *     m_face;
	Vertex   *     m_vertex;		//target vertex
	HalfEdge *	   m_prev;
	HalfEdge *     m_next;
};

#endif 